CREATE OR REPLACE PROCEDURE CALC_DIFAL_FCP_NC(
   P_NRSEQUMAPAPU    IN MAPAAPURAC.NRSEQUMAPAPU%TYPE,
   P_CDEMPRESA       IN MAPAAPURAC.CDEMPRESA%TYPE,
   P_CDINSCESTA      IN MAPAAPURAC.CDINSCESTA%TYPE)
AS
   V_NRSEQMAPAPURESTNC  NUMBER;
   V_NRSEQMAPARECUPNC   NUMBER;
   V_VROUTRDEBIDIFAL    FLOAT;
   V_VRESTOCREDDIFAL    FLOAT;
   V_VROUTRCREDDIFAL    FLOAT;
   V_VRESTODEBIDIFAL    FLOAT;
   V_VRDEDUCAODIFAL     FLOAT;
   V_VROUTRDEBIFCP      FLOAT;
   V_VRESTOCREDFCP      FLOAT;
   V_VROUTRCREDFCP      FLOAT;
   V_VRESTODEBIFCP      FLOAT;
   V_VRDEDUCAOFCP       FLOAT;
   V_VRSLDCRANTEDIFAL   FLOAT;
   V_VRSLDCRANTEFCP     FLOAT;
   V_TOTALDEBDIFAL      FLOAT;
   V_TOTALCREDDIFAL     FLOAT;
   V_SALDODIFAL         FLOAT;
   V_TOTALDEBFCP        FLOAT;
   V_TOTALCREDFCP       FLOAT;
   V_SALDOFCP           FLOAT;
BEGIN

   DELETE FROM MAPARECUPNC
    WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;

   FOR C_NOTAS IN (SELECT NVL(SUM(VRDIFALORIG),0) AS VRDIFALORIG, NVL(SUM(VRDIFALDEST),0) AS VRDIFALDEST, NVL(SUM(VRFCP),0) AS VRFCP,
                          IDENTRSAIDOP, UF_ORIGEM, UF_DESTINO, MIN(IDINSCRICAOST) AS IDINSCRICAOST
                     FROM (SELECT NF.IDENTRSAIDOP, FL.SGESTADO AS UF_ORIGEM, NVL(FO.SGESTADO,NVL(CL.SGESTADO, FI.SGESTADO)) AS UF_DESTINO,
                                  SUM(DECODE(NF.IDENTRSAIDOP,'S',IT.VRIMPOPARTREME,DECODE(C.IDTIPOCFOP,'D',IT.VRIMPOPARTREME,0))) AS VRDIFALORIG,
                                  SUM(DECODE(NF.IDENTRSAIDOP,'S',IT.VRIMPOPARTDEST,DECODE(C.IDTIPOCFOP,'D',IT.VRIMPOPARTDEST,0))) AS VRDIFALDEST,
                                  SUM(DECODE(NF.IDENTRSAIDOP,'S',IT.VRIMPOFCP,DECODE(C.IDTIPOCFOP,'D',IT.VRIMPOFCP,0))) AS VRFCP, 'N' AS IDINSCRICAOST
                             FROM NOTAFISCAL NF, CFOPPADRAO C, ITEMPROIMPOS IT, IMPOSTO IM, ENDECLIE CL, ENDEFORN FO, ENDEFILI FI, ENDEFILI FL,
                                  (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                     FROM IMPOSTONF I
                                    WHERE I.NRSEQUMAPAPU = P_NRSEQUMAPAPU) IP
                            WHERE NF.CDFILIAL   = IP.CDFILIAL
                              AND NF.NRLANCTONF = IP.NRLANCTONF
                              AND NF.CDFILIAL   = IT.CDFILIAL
                              AND NF.NRLANCTONF = IT.NRLANCTONF
                              AND IT.CDIMPOSTO  = IM.CDIMPOSTO
                              AND IM.CDIMPOSTONFE = '00'
                              AND NF.CDCLIENTE  = CL.CDCLIENTE(+)
                              AND CL.IDTPENDECLIE(+) = 'P'
                              AND NF.CDFORNECED = FO.CDFORNECED(+)
                              AND FO.IDTPENDEFORN(+) = 'P'
                              AND NF.IDENTRSAIDOP = 'S'
                              AND DECODE(NF.IDENTRSAIDOP,'S',NF.CDFILIRECE,NF.CDFILIEMIT) = FI.CDFILIAL(+)
                              AND FI.IDTPENDEFILI(+) = 'P'
                              AND DECODE(NF.IDENTRSAIDOP,'S',NF.CDFILIEMIT,NF.CDFILIRECE) = FL.CDFILIAL
                              AND FL.IDTPENDEFILI = 'P'
                              AND IT.CDFISCOPERIT = C.CDCFOPPADRAO
                            GROUP BY NF.IDENTRSAIDOP, FL.SGESTADO, NVL(FO.SGESTADO,NVL(CL.SGESTADO, FI.SGESTADO))
                            UNION ALL
                           SELECT 'S' AS IDENTRSAIDOP, IE.SGESTADO AS UF_ORIGEM, I.SGESTADO AS UF_DESTINO, 0 AS VRDIFALORIG,
                                  0 AS VRDIFALDEST, 0 AS VRFCP, 'S' AS IDINSCRICAOST
                             FROM INSCRESTADST I, INSCRESTAD IE
                            WHERE I.CDEMPRESA    = P_CDEMPRESA
                              AND I.CDINSCESTA   = P_CDINSCESTA
                              AND I.CDEMPRESA    = IE.CDEMPRESA
                              AND I.CDINSCESTA   = IE.CDINSCESTA
                              AND I.IDATIVINSCST = 'S')
                    WHERE VRDIFALORIG > 0 OR VRDIFALDEST > 0 OR VRFCP > 0 OR IDINSCRICAOST = 'S'
                    GROUP BY IDENTRSAIDOP, UF_ORIGEM, UF_DESTINO) LOOP

      /******** UF de Origem *********/
      /******** A UF de origem s ser considerada se houver movimento ********/
      IF C_NOTAS.IDINSCRICAOST = 'N' THEN
         /******** Verifica se j existe a UF cadastrada ********/
         V_NRSEQMAPAPURESTNC := 0;
         BEGIN
            SELECT NRSEQMAPAPURESTNC
              INTO V_NRSEQMAPAPURESTNC
              FROM MAPAAPURESTADONC
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU
               AND CDPAIS       = '0055'
               AND SGESTADO     = C_NOTAS.UF_ORIGEM;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRSEQMAPAPURESTNC := 0;
         END;

         IF NVL(V_NRSEQMAPAPURESTNC,0) = 0 THEN
            /******** Se no existir, cria o registro da UF e o detalhamento ********/
            NOVO_CODIGO_NT('MAPAAPURESTADONC',V_NRSEQMAPAPURESTNC);
            INSERT INTO MAPAAPURESTADONC
               (NRSEQMAPAPURESTNC, NRSEQUMAPAPU, CDPAIS, SGESTADO, VRIMPRECDIFAL, VRIMPRECFCP, VRIMPRECOLHER, IDUFORIGDEST)
            VALUES
               (V_NRSEQMAPAPURESTNC, P_NRSEQUMAPAPU, '0055', C_NOTAS.UF_ORIGEM, 0, 0, 0, 'O');

            NOVO_CODIGO_NT('MAPARECUPNC',V_NRSEQMAPARECUPNC);
            INSERT INTO MAPARECUPNC
               (NRSEQMAPARECUPNC, NRSEQUMAPAPU, NRSEQMAPAPURESTNC,
                VRDEBIDIFAL, VROUTRDEBIDIFAL, VRESTOCREDDIFAL, VRTOTADEBIDIFAL,
                VRCREDDIFAL, VROUTRCREDDIFAL, VRESTODEBIDIFAL, VRTOTACREDDIFAL,
                VRSLDCRANTEDIFAL, VRDEDUCAODIFAL, VRSALDOCREDDIFAL, VRSALDODEVEDIFAL,
                VRDEBIFCP, VROUTRDEBIFCP, VRESTOCREDFCP, VRTOTADEBIFCP,
                VRCREDFCP, VROUTRCREDFCP, VRESTODEBIFCP, VRTOTACREDFCP,
                VRSLDCRANTEFCP, VRDEDUCAOFCP, VRSALDOCREDFCP, VRSALDODEVEFCP)
            VALUES
               (V_NRSEQMAPARECUPNC, P_NRSEQUMAPAPU, V_NRSEQMAPAPURESTNC, 0, 0, 0,
                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
         ELSE
            V_NRSEQMAPARECUPNC := 0;
            BEGIN
               SELECT NRSEQMAPAPURESTNC
                 INTO V_NRSEQMAPARECUPNC
                 FROM MAPARECUPNC
                WHERE NRSEQUMAPAPU      = P_NRSEQUMAPAPU
                  AND NRSEQMAPAPURESTNC = V_NRSEQMAPAPURESTNC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_NRSEQMAPARECUPNC := 0;
            END;
            IF NVL(V_NRSEQMAPARECUPNC,0) = 0 THEN
               NOVO_CODIGO_NT('MAPARECUPNC',V_NRSEQMAPARECUPNC);
               INSERT INTO MAPARECUPNC
                  (NRSEQMAPARECUPNC, NRSEQUMAPAPU, NRSEQMAPAPURESTNC,
                VRDEBIDIFAL, VROUTRDEBIDIFAL, VRESTOCREDDIFAL, VRTOTADEBIDIFAL,
                VRCREDDIFAL, VROUTRCREDDIFAL, VRESTODEBIDIFAL, VRTOTACREDDIFAL,
                VRSLDCRANTEDIFAL, VRDEDUCAODIFAL, VRSALDOCREDDIFAL, VRSALDODEVEDIFAL,
                VRDEBIFCP, VROUTRDEBIFCP, VRESTOCREDFCP, VRTOTADEBIFCP,
                VRCREDFCP, VROUTRCREDFCP, VRESTODEBIFCP, VRTOTACREDFCP,
                VRSLDCRANTEFCP, VRDEDUCAOFCP, VRSALDOCREDFCP, VRSALDODEVEFCP)
               VALUES
                  (V_NRSEQMAPARECUPNC, P_NRSEQUMAPAPU, V_NRSEQMAPAPURESTNC, 0, 0, 0,
                   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
            END IF;
         END IF;

         /******** Atualiza o valor ********/
         UPDATE MAPARECUPNC
            SET VRDEBIDIFAL = NVL(VRDEBIDIFAL,0) + DECODE(C_NOTAS.IDENTRSAIDOP,'S',C_NOTAS.VRDIFALORIG,0),
	             VRCREDDIFAL = NVL(VRCREDDIFAL,0) + DECODE(C_NOTAS.IDENTRSAIDOP,'E',C_NOTAS.VRDIFALORIG,0)
          WHERE NRSEQMAPAPURESTNC = V_NRSEQMAPAPURESTNC;
      END IF;
      /******** UF de destino ********/
      /******** Verifica se j existe a UF cadastrada ********/
      V_NRSEQMAPAPURESTNC := 0;
      BEGIN
         SELECT NRSEQMAPAPURESTNC
           INTO V_NRSEQMAPAPURESTNC
           FROM MAPAAPURESTADONC
          WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU
            AND CDPAIS       = '0055'
            AND SGESTADO     = C_NOTAS.UF_DESTINO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRSEQMAPAPURESTNC := 0;
      END;

      IF NVL(V_NRSEQMAPAPURESTNC,0) = 0 THEN
         /******** Se no existir, cria o registro da UF e o detalhamento ********/
         NOVO_CODIGO_NT('MAPAAPURESTADONC',V_NRSEQMAPAPURESTNC);
         INSERT INTO MAPAAPURESTADONC
            (NRSEQMAPAPURESTNC, NRSEQUMAPAPU, CDPAIS, SGESTADO, VRIMPRECDIFAL, VRIMPRECFCP, VRIMPRECOLHER, IDUFORIGDEST)
         VALUES
            (V_NRSEQMAPAPURESTNC, P_NRSEQUMAPAPU, '0055', C_NOTAS.UF_DESTINO, 0, 0, 0, 'D');

         NOVO_CODIGO_NT('MAPARECUPNC',V_NRSEQMAPARECUPNC);
         INSERT INTO MAPARECUPNC
            (NRSEQMAPARECUPNC, NRSEQUMAPAPU, NRSEQMAPAPURESTNC,
             VRDEBIDIFAL, VROUTRDEBIDIFAL, VRESTOCREDDIFAL, VRTOTADEBIDIFAL,
             VRCREDDIFAL, VROUTRCREDDIFAL, VRESTODEBIDIFAL, VRTOTACREDDIFAL,
             VRSLDCRANTEDIFAL, VRDEDUCAODIFAL, VRSALDOCREDDIFAL, VRSALDODEVEDIFAL,
             VRDEBIFCP, VROUTRDEBIFCP, VRESTOCREDFCP, VRTOTADEBIFCP,
             VRCREDFCP, VROUTRCREDFCP, VRESTODEBIFCP, VRTOTACREDFCP,
             VRSLDCRANTEFCP, VRDEDUCAOFCP, VRSALDOCREDFCP, VRSALDODEVEFCP)
         VALUES
             (V_NRSEQMAPARECUPNC, P_NRSEQUMAPAPU, V_NRSEQMAPAPURESTNC, 0, 0, 0,
              0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
      ELSE
         V_NRSEQMAPARECUPNC := 0;
         BEGIN
            SELECT NRSEQMAPAPURESTNC
              INTO V_NRSEQMAPARECUPNC
              FROM MAPARECUPNC
             WHERE NRSEQUMAPAPU      = P_NRSEQUMAPAPU
               AND NRSEQMAPAPURESTNC = V_NRSEQMAPAPURESTNC;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRSEQMAPARECUPNC := 0;
         END;
         IF NVL(V_NRSEQMAPARECUPNC,0) = 0 THEN
            NOVO_CODIGO_NT('MAPARECUPNC',V_NRSEQMAPARECUPNC);
            INSERT INTO MAPARECUPNC
               (NRSEQMAPARECUPNC, NRSEQUMAPAPU, NRSEQMAPAPURESTNC,
                VRDEBIDIFAL, VROUTRDEBIDIFAL, VRESTOCREDDIFAL, VRTOTADEBIDIFAL,
                VRCREDDIFAL, VROUTRCREDDIFAL, VRESTODEBIDIFAL, VRTOTACREDDIFAL,
                VRSLDCRANTEDIFAL, VRDEDUCAODIFAL, VRSALDOCREDDIFAL, VRSALDODEVEDIFAL,
                VRDEBIFCP, VROUTRDEBIFCP, VRESTOCREDFCP, VRTOTADEBIFCP,
                VRCREDFCP, VROUTRCREDFCP, VRESTODEBIFCP, VRTOTACREDFCP,
                VRSLDCRANTEFCP, VRDEDUCAOFCP, VRSALDOCREDFCP, VRSALDODEVEFCP)
            VALUES
               (V_NRSEQMAPARECUPNC, P_NRSEQUMAPAPU, V_NRSEQMAPAPURESTNC, 0, 0, 0,
                0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
         END IF;
      END IF;

      /******** Atualiza o valor ********/
      UPDATE MAPARECUPNC
         SET VRDEBIDIFAL = NVL(VRDEBIDIFAL,0) + DECODE(C_NOTAS.IDENTRSAIDOP,'S',C_NOTAS.VRDIFALDEST,0),
             VRDEBIFCP   = NVL(VRDEBIFCP,  0) + DECODE(C_NOTAS.IDENTRSAIDOP,'S',C_NOTAS.VRFCP,0),
             VRCREDDIFAL = NVL(VRCREDDIFAL,0) + DECODE(C_NOTAS.IDENTRSAIDOP,'E',C_NOTAS.VRDIFALDEST,0),
             VRCREDFCP   = NVL(VRCREDFCP,  0) + DECODE(C_NOTAS.IDENTRSAIDOP,'E',C_NOTAS.VRFCP,0)
       WHERE NRSEQMAPAPURESTNC = V_NRSEQMAPAPURESTNC;
   END LOOP;

   /******** Atualiza os totalizadores e o imposto a recolher ********/
   FOR C_UF IN (SELECT MR.VRDEBIDIFAL, MR.VRDEBIFCP, MR.VRCREDDIFAL, MR.VRCREDFCP, MR.VRSLDCRANTEDIFAL,
                       MR.VRSLDCRANTEFCP, ME.NRSEQUMAPAPU, ME.NRSEQMAPAPURESTNC, MR.NRSEQMAPARECUPNC, ME.SGESTADO
                  FROM MAPAAPURESTADONC ME, MAPARECUPNC MR
                 WHERE ME.NRSEQUMAPAPU      = P_NRSEQUMAPAPU
                   AND ME.NRSEQUMAPAPU      = MR.NRSEQUMAPAPU
                   AND ME.NRSEQMAPAPURESTNC = MR.NRSEQMAPAPURESTNC) LOOP

      /******** Busca os valores dos ajustes ********/
      BEGIN
         SELECT NVL(SUM(DECODE(IT.IDTIPOITMAPR,'OD',DECODE(IT.IDAJUSTENC,'D',IT.VRITEMMAPR,0),0)),0) AS VROUTRDEBIDIFAL,
                NVL(SUM(DECODE(IT.IDTIPOITMAPR,'EC',DECODE(IT.IDAJUSTENC,'D',IT.VRITEMMAPR,0),0)),0) AS VRESTOCREDDIFAL,
                NVL(SUM(DECODE(IT.IDTIPOITMAPR,'OC',DECODE(IT.IDAJUSTENC,'D',IT.VRITEMMAPR,0),0)),0) AS VROUTRCREDDIFAL,
                NVL(SUM(DECODE(IT.IDTIPOITMAPR,'ED',DECODE(IT.IDAJUSTENC,'D',IT.VRITEMMAPR,0),0)),0) AS VRESTODEBIDIFAL,
                NVL(SUM(DECODE(IT.IDTIPOITMAPR,'DD',DECODE(IT.IDAJUSTENC,'D',IT.VRITEMMAPR,0),0)),0) AS VRDEDUCAODIFAL,
                NVL(SUM(DECODE(IT.IDTIPOITMAPR,'OD',DECODE(IT.IDAJUSTENC,'F',IT.VRITEMMAPR,0),0)),0) AS VROUTRDEBIFCP,
                NVL(SUM(DECODE(IT.IDTIPOITMAPR,'EC',DECODE(IT.IDAJUSTENC,'F',IT.VRITEMMAPR,0),0)),0) AS VRESTOCREDFCP,
                NVL(SUM(DECODE(IT.IDTIPOITMAPR,'OC',DECODE(IT.IDAJUSTENC,'F',IT.VRITEMMAPR,0),0)),0) AS VROUTRCREDFCP,
                NVL(SUM(DECODE(IT.IDTIPOITMAPR,'ED',DECODE(IT.IDAJUSTENC,'F',IT.VRITEMMAPR,0),0)),0) AS VRESTODEBIFCP,
                NVL(SUM(DECODE(IT.IDTIPOITMAPR,'DD',DECODE(IT.IDAJUSTENC,'F',IT.VRITEMMAPR,0),0)),0) AS VRDEDUCAOFCP
           INTO V_VROUTRDEBIDIFAL, V_VRESTOCREDDIFAL, V_VROUTRCREDDIFAL, V_VRESTODEBIDIFAL, V_VRDEDUCAODIFAL,
                V_VROUTRDEBIFCP,   V_VRESTOCREDFCP,   V_VROUTRCREDFCP,   V_VRESTODEBIFCP,   V_VRDEDUCAOFCP
           FROM ITMAPARECUPNC IT
          WHERE IT.NRSEQUMAPAPU      = P_NRSEQUMAPAPU
            AND IT.NRSEQMAPAPURESTNC = C_UF.NRSEQMAPAPURESTNC;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VROUTRDEBIDIFAL := 0;
            V_VRESTOCREDDIFAL := 0;
            V_VROUTRCREDDIFAL := 0;
            V_VRESTODEBIDIFAL := 0;
            V_VRDEDUCAODIFAL  := 0;
            V_VROUTRDEBIFCP   := 0;
            V_VRESTOCREDFCP   := 0;
            V_VROUTRCREDFCP   := 0;
            V_VRESTODEBIFCP   := 0;
            V_VRDEDUCAOFCP    := 0;
      END;

      /******** Busca o valor de saldo credor do mapa anterior ********/
      V_VRSLDCRANTEDIFAL := 0;
      V_VRSLDCRANTEFCP   := 0;
      BEGIN
         SELECT VRSALDOCREDDIFAL, VRSALDOCREDFCP
           INTO V_VRSLDCRANTEDIFAL, V_VRSLDCRANTEFCP
           FROM MAPARECUPNC
          WHERE NRSEQMAPARECUPNC = (SELECT MAX(NRSEQMAPARECUPNC)
                                      FROM MAPAAPURESTADONC ME, MAPARECUPNC MR
                                     WHERE ME.NRSEQUMAPAPU      = MR.NRSEQUMAPAPU
                                       AND ME.NRSEQMAPAPURESTNC = MR.NRSEQMAPAPURESTNC
                                       AND ME.SGESTADO          = C_UF.SGESTADO
                                       AND MR.NRSEQMAPARECUPNC  < C_UF.NRSEQMAPARECUPNC);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRSLDCRANTEDIFAL := 0;
            V_VRSLDCRANTEFCP   := 0;
      END;

      /******** Calcula o valor do imposto ********/
      V_TOTALDEBDIFAL  := C_UF.VRDEBIDIFAL + V_VROUTRDEBIDIFAL + V_VRESTOCREDDIFAL;
      V_TOTALCREDDIFAL := C_UF.VRCREDDIFAL + V_VROUTRCREDDIFAL + V_VRESTODEBIDIFAL;
      V_SALDODIFAL := V_TOTALDEBDIFAL - V_TOTALCREDDIFAL - NVL(V_VRSLDCRANTEDIFAL,0) - V_VRDEDUCAODIFAL;

      V_TOTALDEBFCP  := C_UF.VRDEBIFCP + V_VROUTRDEBIFCP + V_VRESTOCREDFCP;
      V_TOTALCREDFCP := C_UF.VRCREDFCP + V_VROUTRCREDFCP + V_VRESTODEBIFCP;
      V_SALDOFCP := V_TOTALDEBFCP - V_TOTALCREDFCP - NVL(V_VRSLDCRANTEFCP,0) - V_VRDEDUCAOFCP;

      /******** Atualiza os valores na tabela de detalhamento ********/
      UPDATE MAPARECUPNC
         SET VROUTRDEBIDIFAL  = NVL(V_VROUTRDEBIDIFAL,0),
             VRESTOCREDDIFAL  = NVL(V_VRESTOCREDDIFAL,0),
             VRTOTADEBIDIFAL  = NVL(V_TOTALDEBDIFAL,0),
             VROUTRCREDDIFAL  = NVL(V_VROUTRCREDDIFAL,0),
             VRESTODEBIDIFAL  = NVL(V_VRESTODEBIDIFAL,0),
             VRTOTACREDDIFAL  = NVL(V_TOTALCREDDIFAL,0),
             VRSLDCRANTEDIFAL = NVL(V_VRSLDCRANTEDIFAL,C_UF.VRSLDCRANTEDIFAL),
             VRDEDUCAODIFAL   = NVL(V_VRDEDUCAODIFAL,0),
             VRSALDOCREDDIFAL = DECODE(V_SALDODIFAL, ABS(V_SALDODIFAL), 0, ABS(V_SALDODIFAL)),
             VRSALDODEVEDIFAL = DECODE(V_SALDODIFAL, ABS(V_SALDODIFAL), V_SALDODIFAL, 0),
             VROUTRDEBIFCP    = NVL(V_VROUTRDEBIFCP,0),
             VRESTOCREDFCP    = NVL(V_VRESTOCREDFCP,0),
             VRTOTADEBIFCP    = NVL(V_TOTALDEBFCP,0),
             VROUTRCREDFCP    = NVL(V_VROUTRCREDFCP,0),
             VRESTODEBIFCP    = NVL(V_VRESTODEBIFCP,0),
             VRTOTACREDFCP    = NVL(V_TOTALCREDFCP,0),
             VRSLDCRANTEFCP   = NVL(V_VRSLDCRANTEFCP,C_UF.VRSLDCRANTEFCP),
             VRDEDUCAOFCP     = NVL(V_VRDEDUCAOFCP,0),
             VRSALDOCREDFCP   = DECODE(V_SALDOFCP, ABS(V_SALDOFCP), 0, ABS(V_SALDOFCP)),
             VRSALDODEVEFCP   = DECODE(V_SALDOFCP, ABS(V_SALDOFCP), V_SALDOFCP, 0)
       WHERE NRSEQMAPARECUPNC = C_UF.NRSEQMAPARECUPNC;

      /******** Atualiza o valor do imposto a recolher na tabela por estado ********/
      UPDATE MAPAAPURESTADONC
         SET VRIMPRECDIFAL = DECODE(V_SALDODIFAL, ABS(V_SALDODIFAL), V_SALDODIFAL, 0),
             VRIMPRECFCP   = DECODE(V_SALDOFCP, ABS(V_SALDOFCP), V_SALDOFCP, 0),
             VRIMPRECOLHER = DECODE(V_SALDODIFAL, ABS(V_SALDODIFAL),V_SALDODIFAL,0)+DECODE(V_SALDOFCP,ABS(V_SALDOFCP),V_SALDOFCP,0)
       WHERE NRSEQMAPAPURESTNC = C_UF.NRSEQMAPAPURESTNC;
   END LOOP;

   /******** Deleta os estados para os quais no existem mais movimentao ********/
   DELETE FROM GUIAAPURMAPANC G
    WHERE NOT EXISTS (SELECT NRSEQMAPAPURESTNC
                        FROM MAPARECUPNC M
                       WHERE M.NRSEQUMAPAPU      = G.NRSEQUMAPAPU
                         AND M.NRSEQMAPAPURESTNC = G.NRSEQMAPAPURESTNC);

   DELETE FROM ITMAPARECUPNC I
    WHERE NOT EXISTS (SELECT NRSEQMAPAPURESTNC
                        FROM MAPARECUPNC M
                       WHERE M.NRSEQUMAPAPU      = I.NRSEQUMAPAPU
                         AND M.NRSEQMAPAPURESTNC = I.NRSEQMAPAPURESTNC);

   DELETE FROM MAPAAPURESTADONC ME
    WHERE NOT EXISTS (SELECT NRSEQMAPAPURESTNC
                        FROM MAPARECUPNC MR
                       WHERE MR.NRSEQUMAPAPU = ME.NRSEQUMAPAPU
                         AND MR.NRSEQMAPAPURESTNC = ME.NRSEQMAPAPURESTNC);

   /******** Atualiza o valor total do DIFAL e FCP ********/
   UPDATE MAPARECUP
      SET VRDIFALNC = (SELECT SUM(VRIMPRECDIFAL)
                         FROM MAPAAPURESTADONC
                        WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU),
          VRFCPNC   = (SELECT SUM(VRIMPRECFCP)
                         FROM MAPAAPURESTADONC
                        WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU)
    WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CALC_DIFAL_FCP_NC','6.49.058'); END;
/

