package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.EmissaoCardapioDiaFlows;
import com.javaseleniumtemplate.pages.EmissaoCardapioDiaPage;
import org.testng.annotations.Test;

public class EmissaoCardapioDiaTests extends TestBase {

    EmissaoCardapioDiaPage emissaoCardapioDiaPage;
    EmissaoCardapioDiaFlows emissaoCardapioDiaFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioAlergenicos() {
        emitirCardapio("Cardápio do Dia - Alergênicos");
    }

    @Test
    public void relatorioDiaPorData() {
        emitirCardapio("Cardápio do Dia (por Data)");
    }

    @Test
    public void relatorioDiaPorServico() {
        emitirCardapio("Cardápio do Dia (por Serviço)");
    }

    @Test
    public void relatorioEmissaoCardapio() {
        emitirCardapio("Emissão do Cardápio");
    }

    public void emitirCardapio(String nomeRelatorio) {
        emissaoCardapioDiaPage = new EmissaoCardapioDiaPage();
        emissaoCardapioDiaFlows = new EmissaoCardapioDiaFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/08/2022";
        String dataFinal = "30/09/2022";

        loginFlows.efetuarLogin();
        emissaoCardapioDiaFlows.navegateEmissaoCardapioDia();
        emissaoCardapioDiaPage.selecionaRelatorio(nomeRelatorio);
        emissaoCardapioDiaPage.preencherDatas(dataInicial, dataFinal);
        emissaoCardapioDiaPage.geraRelatorio();
        emissaoCardapioDiaPage.selecionarServicos();
        emissaoCardapioDiaPage.geraRelatorio();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //verificar os campos obrigatórios da tela
    //verificar se caso clicar no check-box 'imprimir mensagem', o check-box 'quebra de página' fica desabilitado
    //verificar se após marcar o 'imprimir nutrientes' a opção 'considerar pratos opção' aparece na tela
    //verificar se é possível marcar e desmarcar todos os check-box
    //verificar os check-box que estão habilitados de acordo com o relatório selecionado
    @Test
    public void checkBoxSelecionados() {
        emissaoCardapioDiaPage = new EmissaoCardapioDiaPage();
        emissaoCardapioDiaFlows = new EmissaoCardapioDiaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoCardapioDiaFlows.navegateEmissaoCardapioDia();
        emissaoCardapioDiaPage.camposObrigatorios();
        emissaoCardapioDiaPage.refresh();
        emissaoCardapioDiaPage.desabilitarCheckBoxQuebraPagia();
        emissaoCardapioDiaPage.refresh();
        emissaoCardapioDiaPage.habilitarConsiderarPratosOpcoes();
        emissaoCardapioDiaPage.refresh();
        emissaoCardapioDiaPage.verificarCheckBoxSelecionados();
        emissaoCardapioDiaPage.refresh();
        emissaoCardapioDiaPage.verificarCamposHabilitadosPeloRelatorios();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }




}
